# GNU MediaGoblin -- federated, autonomous media hosting
# Copyright (C) 2011, 2012 MediaGoblin contributors.  See AUTHORS.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from mediagoblin.tools.routing import add_route

# Add user profile
add_route(
    "mediagoblin.federation.user",
    "/api/user/<string:username>/",
    "mediagoblin.federation.views:user"
    )

add_route(
    "mediagoblin.federation.profile",
    "/api/user/<string:username>/profile",
    "mediagoblin.federation.views:user"
    )

# Inbox and Outbox (feed)
add_route(
    "mediagoblin.federation.feed",
    "/api/user/<string:username>/feed",
    "mediagoblin.federation.views:feed"
    )

add_route(
    "mediagoblin.federation.inbox",
    "/api/user/<string:username>/inbox",
    "mediagoblin.federation.views:inbox"
    )

# object endpoints
add_route(
    "mediagoblin.federation.object",
    "/api/<string:objectType>/<string:uuid>",
    "mediagoblin.federation.views:object"
    )
